/* clipboard-configuration.c generated by valac 0.32.1, the Vala compiler
 * generated from clipboard-configuration.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define DIODON_TYPE_CLIPBOARD_CONFIGURATION (diodon_clipboard_configuration_get_type ())
#define DIODON_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration))
#define DIODON_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))
#define DIODON_IS_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_IS_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_CLIPBOARD_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))

typedef struct _DiodonClipboardConfiguration DiodonClipboardConfiguration;
typedef struct _DiodonClipboardConfigurationClass DiodonClipboardConfigurationClass;
typedef struct _DiodonClipboardConfigurationPrivate DiodonClipboardConfigurationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DiodonClipboardConfiguration {
	GObject parent_instance;
	DiodonClipboardConfigurationPrivate * priv;
};

struct _DiodonClipboardConfigurationClass {
	GObjectClass parent_class;
};

struct _DiodonClipboardConfigurationPrivate {
	gint _recent_items_size;
	gboolean _use_primary;
	gboolean _add_images;
	gboolean _use_clipboard;
	gboolean _synchronize_clipboards;
	gboolean _keep_clipboard_content;
	gboolean _instant_paste;
	gchar* _filter_pattern;
	gchar** _app_paste_keybindings;
	gint _app_paste_keybindings_length1;
	gint __app_paste_keybindings_size_;
};


static gpointer diodon_clipboard_configuration_parent_class = NULL;

GType diodon_clipboard_configuration_get_type (void) G_GNUC_CONST;
#define DIODON_CLIPBOARD_CONFIGURATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationPrivate))
enum  {
	DIODON_CLIPBOARD_CONFIGURATION_DUMMY_PROPERTY,
	DIODON_CLIPBOARD_CONFIGURATION_USE_PRIMARY,
	DIODON_CLIPBOARD_CONFIGURATION_ADD_IMAGES,
	DIODON_CLIPBOARD_CONFIGURATION_USE_CLIPBOARD,
	DIODON_CLIPBOARD_CONFIGURATION_SYNCHRONIZE_CLIPBOARDS,
	DIODON_CLIPBOARD_CONFIGURATION_KEEP_CLIPBOARD_CONTENT,
	DIODON_CLIPBOARD_CONFIGURATION_INSTANT_PASTE,
	DIODON_CLIPBOARD_CONFIGURATION_FILTER_PATTERN,
	DIODON_CLIPBOARD_CONFIGURATION_APP_PASTE_KEYBINDINGS,
	DIODON_CLIPBOARD_CONFIGURATION_RECENT_ITEMS_SIZE
};
gchar* diodon_clipboard_configuration_lookup_app_paste_keybinding (DiodonClipboardConfiguration* self, const gchar* apppath);
gchar** diodon_clipboard_configuration_get_app_paste_keybindings (DiodonClipboardConfiguration* self, int* result_length1);
DiodonClipboardConfiguration* diodon_clipboard_configuration_new (void);
DiodonClipboardConfiguration* diodon_clipboard_configuration_construct (GType object_type);
gboolean diodon_clipboard_configuration_get_use_primary (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_use_primary (DiodonClipboardConfiguration* self, gboolean value);
gboolean diodon_clipboard_configuration_get_add_images (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_add_images (DiodonClipboardConfiguration* self, gboolean value);
gboolean diodon_clipboard_configuration_get_use_clipboard (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_use_clipboard (DiodonClipboardConfiguration* self, gboolean value);
gboolean diodon_clipboard_configuration_get_synchronize_clipboards (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_synchronize_clipboards (DiodonClipboardConfiguration* self, gboolean value);
gboolean diodon_clipboard_configuration_get_keep_clipboard_content (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_keep_clipboard_content (DiodonClipboardConfiguration* self, gboolean value);
gboolean diodon_clipboard_configuration_get_instant_paste (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_instant_paste (DiodonClipboardConfiguration* self, gboolean value);
const gchar* diodon_clipboard_configuration_get_filter_pattern (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_filter_pattern (DiodonClipboardConfiguration* self, const gchar* value);
void diodon_clipboard_configuration_set_app_paste_keybindings (DiodonClipboardConfiguration* self, gchar** value, int value_length1);
static gchar** _vala_array_dup1 (gchar** self, int length);
gint diodon_clipboard_configuration_get_recent_items_size (DiodonClipboardConfiguration* self);
void diodon_clipboard_configuration_set_recent_items_size (DiodonClipboardConfiguration* self, gint value);
static void diodon_clipboard_configuration_finalize (GObject* obj);
static void _vala_diodon_clipboard_configuration_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diodon_clipboard_configuration_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Lookup whether app paste keybinding
         *
         * @return app paste keybinding or null if not available
         */
gchar* diodon_clipboard_configuration_lookup_app_paste_keybinding (DiodonClipboardConfiguration* self, const gchar* apppath) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), NULL);
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1_ = diodon_clipboard_configuration_get_app_paste_keybindings (self, &_tmp1__length1);
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp2_ = _tmp1_;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp2__length1 = _tmp1__length1;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	if (_tmp2_ != NULL) {
#line 136 "clipboard-configuration.c"
		const gchar* _tmp3_ = NULL;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp3_ = apppath;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 142 "clipboard-configuration.c"
	} else {
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp0_ = FALSE;
#line 146 "clipboard-configuration.c"
	}
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	if (_tmp0_) {
#line 150 "clipboard-configuration.c"
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		gchar** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp4_ = diodon_clipboard_configuration_get_app_paste_keybindings (self, &_tmp4__length1);
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp5_ = _tmp4_;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp5__length1 = _tmp4__length1;
#line 161 "clipboard-configuration.c"
		{
			gchar** keybinding_collection = NULL;
			gint keybinding_collection_length1 = 0;
			gint _keybinding_collection_size_ = 0;
			gint keybinding_it = 0;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			keybinding_collection = _tmp5_;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			keybinding_collection_length1 = _tmp5__length1;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			for (keybinding_it = 0; keybinding_it < _tmp5__length1; keybinding_it = keybinding_it + 1) {
#line 173 "clipboard-configuration.c"
				gchar* _tmp6_ = NULL;
				gchar* keybinding = NULL;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
				_tmp6_ = g_strdup (keybinding_collection[keybinding_it]);
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
				keybinding = _tmp6_;
#line 180 "clipboard-configuration.c"
				{
					gchar** path_keybinding = NULL;
					const gchar* _tmp7_ = NULL;
					gchar** _tmp8_ = NULL;
					gchar** _tmp9_ = NULL;
					gint path_keybinding_length1 = 0;
					gint _path_keybinding_size_ = 0;
					gchar** _tmp10_ = NULL;
					gint _tmp10__length1 = 0;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_tmp7_ = keybinding;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "|", 0);
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					path_keybinding = _tmp9_;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					path_keybinding_length1 = _vala_array_length (_tmp8_);
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_path_keybinding_size_ = path_keybinding_length1;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_tmp10_ = path_keybinding;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_tmp10__length1 = path_keybinding_length1;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					if (_tmp10__length1 == 2) {
#line 206 "clipboard-configuration.c"
						GCompareFunc _tmp11_ = NULL;
						const gchar* _tmp12_ = NULL;
						gchar** _tmp13_ = NULL;
						gint _tmp13__length1 = 0;
						const gchar* _tmp14_ = NULL;
						gint _tmp15_ = 0;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp11_ = g_strcmp0;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp12_ = apppath;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp13_ = path_keybinding;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp13__length1 = path_keybinding_length1;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp14_ = _tmp13_[0];
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						_tmp15_ = _tmp11_ (_tmp12_, _tmp14_);
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
						if (_tmp15_ == 0) {
#line 227 "clipboard-configuration.c"
							gchar** _tmp16_ = NULL;
							gint _tmp16__length1 = 0;
							const gchar* _tmp17_ = NULL;
							gchar* _tmp18_ = NULL;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							_tmp16_ = path_keybinding;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							_tmp16__length1 = path_keybinding_length1;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							_tmp17_ = _tmp16_[1];
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							_tmp18_ = g_strdup (_tmp17_);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							result = _tmp18_;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							path_keybinding = (_vala_array_free (path_keybinding, path_keybinding_length1, (GDestroyNotify) g_free), NULL);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							_g_free0 (keybinding);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
							return result;
#line 248 "clipboard-configuration.c"
						}
					}
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					path_keybinding = (_vala_array_free (path_keybinding, path_keybinding_length1, (GDestroyNotify) g_free), NULL);
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
					_g_free0 (keybinding);
#line 255 "clipboard-configuration.c"
				}
			}
		}
	}
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = NULL;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 264 "clipboard-configuration.c"
}


DiodonClipboardConfiguration* diodon_clipboard_configuration_construct (GType object_type) {
	DiodonClipboardConfiguration * self = NULL;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self = (DiodonClipboardConfiguration*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return self;
#line 274 "clipboard-configuration.c"
}


DiodonClipboardConfiguration* diodon_clipboard_configuration_new (void) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return diodon_clipboard_configuration_construct (DIODON_TYPE_CLIPBOARD_CONFIGURATION);
#line 281 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_use_primary (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_use_primary;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 296 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_use_primary (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_use_primary = _tmp0_;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "use-primary");
#line 310 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_add_images (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_add_images;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 325 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_add_images (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_add_images = _tmp0_;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "add-images");
#line 339 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_use_clipboard (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_use_clipboard;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 354 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_use_clipboard (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_use_clipboard = _tmp0_;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "use-clipboard");
#line 368 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_synchronize_clipboards (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_synchronize_clipboards;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 383 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_synchronize_clipboards (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_synchronize_clipboards = _tmp0_;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "synchronize-clipboards");
#line 397 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_keep_clipboard_content (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_keep_clipboard_content;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 412 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_keep_clipboard_content (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_keep_clipboard_content = _tmp0_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "keep-clipboard-content");
#line 426 "clipboard-configuration.c"
}


gboolean diodon_clipboard_configuration_get_instant_paste (DiodonClipboardConfiguration* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), FALSE);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_instant_paste;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 441 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_instant_paste (DiodonClipboardConfiguration* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_instant_paste = _tmp0_;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "instant-paste");
#line 455 "clipboard-configuration.c"
}


const gchar* diodon_clipboard_configuration_get_filter_pattern (DiodonClipboardConfiguration* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), NULL);
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_filter_pattern;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 470 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_filter_pattern (DiodonClipboardConfiguration* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_g_free0 (self->priv->_filter_pattern);
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_filter_pattern = _tmp1_;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "filter-pattern");
#line 489 "clipboard-configuration.c"
}


gchar** diodon_clipboard_configuration_get_app_paste_keybindings (DiodonClipboardConfiguration* self, int* result_length1) {
	gchar** result;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), NULL);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_app_paste_keybindings;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0__length1 = self->priv->_app_paste_keybindings_length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1_ = _tmp0_;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1__length1 = _tmp0__length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	if (result_length1) {
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		*result_length1 = _tmp1__length1;
#line 513 "clipboard-configuration.c"
	}
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp1_;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 519 "clipboard-configuration.c"
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = g_new0 (gchar*, length + 1);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	for (i = 0; i < length; i++) {
#line 530 "clipboard-configuration.c"
		gchar* _tmp0_ = NULL;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp0_ = g_strdup (self[i]);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		result[i] = _tmp0_;
#line 536 "clipboard-configuration.c"
	}
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 540 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_app_paste_keybindings (DiodonClipboardConfiguration* self, gchar** value, int value_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = value;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0__length1 = value_length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1__length1 = _tmp0__length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_app_paste_keybindings = (_vala_array_free (self->priv->_app_paste_keybindings, self->priv->_app_paste_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_app_paste_keybindings = _tmp1_;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_app_paste_keybindings_length1 = _tmp1__length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->__app_paste_keybindings_size_ = self->priv->_app_paste_keybindings_length1;
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "app-paste-keybindings");
#line 569 "clipboard-configuration.c"
}


gint diodon_clipboard_configuration_get_recent_items_size (DiodonClipboardConfiguration* self) {
	gint result;
	gint _tmp0_ = 0;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self), 0);
#line 102 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = self->priv->_recent_items_size;
#line 102 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	result = _tmp0_;
#line 102 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	return result;
#line 584 "clipboard-configuration.c"
}


void diodon_clipboard_configuration_set_recent_items_size (DiodonClipboardConfiguration* self, gint value) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (self));
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp1_ = value;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	if (_tmp1_ > 0) {
#line 597 "clipboard-configuration.c"
		gint _tmp2_ = 0;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp2_ = value;
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp0_ = _tmp2_ <= 100;
#line 603 "clipboard-configuration.c"
	} else {
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp0_ = FALSE;
#line 607 "clipboard-configuration.c"
	}
#line 105 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	if (_tmp0_) {
#line 611 "clipboard-configuration.c"
		gint _tmp3_ = 0;
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		_tmp3_ = value;
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		self->priv->_recent_items_size = _tmp3_;
#line 617 "clipboard-configuration.c"
	}
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_notify ((GObject *) self, "recent-items-size");
#line 621 "clipboard-configuration.c"
}


static void diodon_clipboard_configuration_class_init (DiodonClipboardConfigurationClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	diodon_clipboard_configuration_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_type_class_add_private (klass, sizeof (DiodonClipboardConfigurationPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diodon_clipboard_configuration_get_property;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diodon_clipboard_configuration_set_property;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_clipboard_configuration_finalize;
#line 636 "clipboard-configuration.c"
	/**
	         * flag whether primary selection is enabled
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_USE_PRIMARY, g_param_spec_boolean ("use-primary", "use-primary", "use-primary", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 642 "clipboard-configuration.c"
	/**
	         * flag whether images should be aded to clipboard history
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_ADD_IMAGES, g_param_spec_boolean ("add-images", "add-images", "add-images", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 648 "clipboard-configuration.c"
	/**
	         * flag whether clipboard is enabled
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_USE_CLIPBOARD, g_param_spec_boolean ("use-clipboard", "use-clipboard", "use-clipboard", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 654 "clipboard-configuration.c"
	/**
	         * flag whether clipboards should be in sync
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 660 "clipboard-configuration.c"
	/**
	         * flag whether clipboard content should be restored when lost.
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_KEEP_CLIPBOARD_CONTENT, g_param_spec_boolean ("keep-clipboard-content", "keep-clipboard-content", "keep-clipboard-content", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 666 "clipboard-configuration.c"
	/**
	         * flag whether clipboard content should be automatically pasted
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_INSTANT_PASTE, g_param_spec_boolean ("instant-paste", "instant-paste", "instant-paste", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 672 "clipboard-configuration.c"
	/**
	         * regex pattern so all clipboard items matching this pattern will
	         * be filtered and not added to clipboard history.
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_FILTER_PATTERN, g_param_spec_string ("filter-pattern", "filter-pattern", "filter-pattern", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 679 "clipboard-configuration.c"
	/**
	         * a lookup dictionary for application using different paste keybindings
	         * than <Ctrl>V.
	         * pattern of each string in this array is path-app|<keybinding>
	         * e.g. /usr/bin/gnome-terminal|<Ctrl><Shift>V
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_APP_PASTE_KEYBINDINGS, g_param_spec_boxed ("app-paste-keybindings", "app-paste-keybindings", "app-paste-keybindings", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 688 "clipboard-configuration.c"
	/**
	         * number of recent items to be shown.
	         * Value must be bigger than 0 and lower or equal than 100.
	         */
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_CONFIGURATION_RECENT_ITEMS_SIZE, g_param_spec_int ("recent-items-size", "recent-items-size", "recent-items-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 695 "clipboard-configuration.c"
}


static void diodon_clipboard_configuration_instance_init (DiodonClipboardConfiguration * self) {
	gchar* _tmp0_ = NULL;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv = DIODON_CLIPBOARD_CONFIGURATION_GET_PRIVATE (self);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_recent_items_size = 25;
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_use_primary = FALSE;
#line 38 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_add_images = FALSE;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_use_clipboard = TRUE;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_synchronize_clipboards = FALSE;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_keep_clipboard_content = TRUE;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_instant_paste = TRUE;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_tmp0_ = g_strdup ("^\\s+$");
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_filter_pattern = _tmp0_;
#line 721 "clipboard-configuration.c"
}


static void diodon_clipboard_configuration_finalize (GObject* obj) {
	DiodonClipboardConfiguration * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration);
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	_g_free0 (self->priv->_filter_pattern);
#line 72 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	self->priv->_app_paste_keybindings = (_vala_array_free (self->priv->_app_paste_keybindings, self->priv->_app_paste_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	G_OBJECT_CLASS (diodon_clipboard_configuration_parent_class)->finalize (obj);
#line 735 "clipboard-configuration.c"
}


/**
     * Clipboard configuration encapsulating configuration state.
     */
GType diodon_clipboard_configuration_get_type (void) {
	static volatile gsize diodon_clipboard_configuration_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_clipboard_configuration_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonClipboardConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_clipboard_configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonClipboardConfiguration), 0, (GInstanceInitFunc) diodon_clipboard_configuration_instance_init, NULL };
		GType diodon_clipboard_configuration_type_id;
		diodon_clipboard_configuration_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonClipboardConfiguration", &g_define_type_info, 0);
		g_once_init_leave (&diodon_clipboard_configuration_type_id__volatile, diodon_clipboard_configuration_type_id);
	}
	return diodon_clipboard_configuration_type_id__volatile;
}


static void _vala_diodon_clipboard_configuration_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DiodonClipboardConfiguration * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_USE_PRIMARY:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_use_primary (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_ADD_IMAGES:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_add_images (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_USE_CLIPBOARD:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_use_clipboard (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_SYNCHRONIZE_CLIPBOARDS:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_synchronize_clipboards (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_KEEP_CLIPBOARD_CONTENT:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_keep_clipboard_content (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_INSTANT_PASTE:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_boolean (value, diodon_clipboard_configuration_get_instant_paste (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_FILTER_PATTERN:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_string (value, diodon_clipboard_configuration_get_filter_pattern (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_APP_PASTE_KEYBINDINGS:
#line 803 "clipboard-configuration.c"
		{
			int length;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			g_value_set_boxed (value, diodon_clipboard_configuration_get_app_paste_keybindings (self, &length));
#line 808 "clipboard-configuration.c"
		}
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_RECENT_ITEMS_SIZE:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		g_value_set_int (value, diodon_clipboard_configuration_get_recent_items_size (self));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 818 "clipboard-configuration.c"
		default:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 824 "clipboard-configuration.c"
	}
}


static void _vala_diodon_clipboard_configuration_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DiodonClipboardConfiguration * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_USE_PRIMARY:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_use_primary (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_ADD_IMAGES:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_add_images (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_USE_CLIPBOARD:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_use_clipboard (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_SYNCHRONIZE_CLIPBOARDS:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_synchronize_clipboards (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_KEEP_CLIPBOARD_CONTENT:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_keep_clipboard_content (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_INSTANT_PASTE:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_instant_paste (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_FILTER_PATTERN:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_filter_pattern (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_APP_PASTE_KEYBINDINGS:
#line 878 "clipboard-configuration.c"
		{
			gpointer boxed;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			boxed = g_value_get_boxed (value);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
			diodon_clipboard_configuration_set_app_paste_keybindings (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 885 "clipboard-configuration.c"
		}
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		case DIODON_CLIPBOARD_CONFIGURATION_RECENT_ITEMS_SIZE:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		diodon_clipboard_configuration_set_recent_items_size (self, g_value_get_int (value));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 895 "clipboard-configuration.c"
		default:
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-configuration.vala"
		break;
#line 901 "clipboard-configuration.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



