/* clipboard-manager.c generated by valac 0.32.1, the Vala compiler
 * generated from clipboard-manager.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define DIODON_TYPE_CLIPBOARD_MANAGER (diodon_clipboard_manager_get_type ())
#define DIODON_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_MANAGER, DiodonClipboardManager))
#define DIODON_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_MANAGER, DiodonClipboardManagerClass))
#define DIODON_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_MANAGER))
#define DIODON_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_MANAGER))
#define DIODON_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_MANAGER, DiodonClipboardManagerClass))

typedef struct _DiodonClipboardManager DiodonClipboardManager;
typedef struct _DiodonClipboardManagerClass DiodonClipboardManagerClass;
typedef struct _DiodonClipboardManagerPrivate DiodonClipboardManagerPrivate;

#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

#define DIODON_TYPE_CLIPBOARD_CONFIGURATION (diodon_clipboard_configuration_get_type ())
#define DIODON_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration))
#define DIODON_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))
#define DIODON_IS_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_IS_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_CLIPBOARD_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))

typedef struct _DiodonClipboardConfiguration DiodonClipboardConfiguration;
typedef struct _DiodonClipboardConfigurationClass DiodonClipboardConfigurationClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};

struct _DiodonClipboardManager {
	GObject parent_instance;
	DiodonClipboardManagerPrivate * priv;
	DiodonClipboardType type;
	GtkClipboard* _clipboard;
	DiodonClipboardConfiguration* _configuration;
};

struct _DiodonClipboardManagerClass {
	GObjectClass parent_class;
	void (*start) (DiodonClipboardManager* self);
	void (*stop) (DiodonClipboardManager* self);
	void (*select_item) (DiodonClipboardManager* self, DiodonIClipboardItem* item);
};


static gpointer diodon_clipboard_manager_parent_class = NULL;

GType diodon_clipboard_manager_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_configuration_get_type (void) G_GNUC_CONST;
enum  {
	DIODON_CLIPBOARD_MANAGER_DUMMY_PROPERTY,
	DIODON_CLIPBOARD_MANAGER_CLIPBOARD_TYPE
};
DiodonClipboardManager* diodon_clipboard_manager_new (DiodonClipboardType type, DiodonClipboardConfiguration* configuration);
DiodonClipboardManager* diodon_clipboard_manager_construct (GType object_type, DiodonClipboardType type, DiodonClipboardConfiguration* configuration);
void diodon_clipboard_manager_start (DiodonClipboardManager* self);
static void diodon_clipboard_manager_real_start (DiodonClipboardManager* self);
void diodon_clipboard_manager_check_clipboard (DiodonClipboardManager* self);
static void _diodon_clipboard_manager_check_clipboard_gtk_clipboard_owner_change (GtkClipboard* _sender, GdkEvent* p0, gpointer self);
void diodon_clipboard_manager_stop (DiodonClipboardManager* self);
static void diodon_clipboard_manager_real_stop (DiodonClipboardManager* self);
void diodon_clipboard_manager_select_item (DiodonClipboardManager* self, DiodonIClipboardItem* item);
static void diodon_clipboard_manager_real_select_item (DiodonClipboardManager* self, DiodonIClipboardItem* item);
void diodon_iclipboard_item_to_clipboard (DiodonIClipboardItem* self, GtkClipboard* clipboard);
void diodon_clipboard_manager_clear (DiodonClipboardManager* self);
gchar* diodon_clipboard_manager_request_text (DiodonClipboardManager* self);
gboolean diodon_clipboard_configuration_get_add_images (DiodonClipboardConfiguration* self);
gchar* diodon_utility_get_path_of_active_application (void);
GdkPixbuf* diodon_clipboard_manager_request_image (DiodonClipboardManager* self);
void diodon_clipboard_manager_check_clipboard_emptiness (DiodonClipboardManager* self);
DiodonClipboardType diodon_clipboard_manager_get_clipboard_type (DiodonClipboardManager* self);
static void g_cclosure_user_marshal_VOID__ENUM_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__ENUM_OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void diodon_clipboard_manager_finalize (GObject* obj);
static void _vala_diodon_clipboard_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


/**
         * Constructor
         *
         * @param clipboard clipboard to be managed
         * @param configuration access to clipboard configuration
         * @param type of clipboard
         */
static gpointer _g_object_ref0 (gpointer self) {
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "clipboard-manager.c"
}


DiodonClipboardManager* diodon_clipboard_manager_construct (GType object_type, DiodonClipboardType type, DiodonClipboardConfiguration* configuration) {
	DiodonClipboardManager * self = NULL;
	DiodonClipboardType _tmp0_ = 0;
	DiodonClipboardType _tmp6_ = 0;
	DiodonClipboardConfiguration* _tmp7_ = NULL;
	DiodonClipboardConfiguration* _tmp8_ = NULL;
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (configuration), NULL);
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	self = (DiodonClipboardManager*) g_object_new (object_type, NULL);
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = type;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp0_ == DIODON_CLIPBOARD_TYPE_CLIPBOARD) {
#line 181 "clipboard-manager.c"
		GtkClipboard* _tmp1_ = NULL;
		GtkClipboard* _tmp2_ = NULL;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp1_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_g_object_unref0 (self->_clipboard);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		self->_clipboard = _tmp2_;
#line 192 "clipboard-manager.c"
	} else {
		DiodonClipboardType _tmp3_ = 0;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp3_ = type;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		if (_tmp3_ == DIODON_CLIPBOARD_TYPE_PRIMARY) {
#line 199 "clipboard-manager.c"
			GtkClipboard* _tmp4_ = NULL;
			GtkClipboard* _tmp5_ = NULL;
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			_tmp4_ = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			_g_object_unref0 (self->_clipboard);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			self->_clipboard = _tmp5_;
#line 210 "clipboard-manager.c"
		}
	}
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp6_ = type;
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	self->type = _tmp6_;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp7_ = configuration;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_g_object_unref0 (self->_configuration);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	self->_configuration = _tmp8_;
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return self;
#line 227 "clipboard-manager.c"
}


DiodonClipboardManager* diodon_clipboard_manager_new (DiodonClipboardType type, DiodonClipboardConfiguration* configuration) {
#line 80 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return diodon_clipboard_manager_construct (DIODON_TYPE_CLIPBOARD_MANAGER, type, configuration);
#line 234 "clipboard-manager.c"
}


/**
         * Starts the process requesting data from encapsulated clipboard.
         * The owner has to change when new data is set in the clipboard
         * therefore just connecting to owner_change will do the trick.
         */
static void _diodon_clipboard_manager_check_clipboard_gtk_clipboard_owner_change (GtkClipboard* _sender, GdkEvent* p0, gpointer self) {
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	diodon_clipboard_manager_check_clipboard ((DiodonClipboardManager*) self);
#line 246 "clipboard-manager.c"
}


static void diodon_clipboard_manager_real_start (DiodonClipboardManager* self) {
	GtkClipboard* _tmp0_ = NULL;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_connect_object (_tmp0_, "owner-change", (GCallback) _diodon_clipboard_manager_check_clipboard_gtk_clipboard_owner_change, self, 0);
#line 256 "clipboard-manager.c"
}


void diodon_clipboard_manager_start (DiodonClipboardManager* self) {
#line 98 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 98 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	DIODON_CLIPBOARD_MANAGER_GET_CLASS (self)->start (self);
#line 265 "clipboard-manager.c"
}


/**
         * Stop the process requesting data from encapsulated clipboard.
         */
static void diodon_clipboard_manager_real_stop (DiodonClipboardManager* self) {
	GtkClipboard* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_parse_name ("owner-change", gtk_clipboard_get_type (), &_tmp1_, NULL, FALSE);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _diodon_clipboard_manager_check_clipboard_gtk_clipboard_owner_change, self);
#line 281 "clipboard-manager.c"
}


void diodon_clipboard_manager_stop (DiodonClipboardManager* self) {
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	DIODON_CLIPBOARD_MANAGER_GET_CLASS (self)->stop (self);
#line 290 "clipboard-manager.c"
}


/**
         * Select item in the managed clipboard.
         *
         * @param item item to be selected
         */
static void diodon_clipboard_manager_real_select_item (DiodonClipboardManager* self, DiodonIClipboardItem* item) {
	DiodonIClipboardItem* _tmp0_ = NULL;
	GtkClipboard* _tmp1_ = NULL;
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_ICLIPBOARD_ITEM (item));
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = item;
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp1_ = self->_clipboard;
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	diodon_iclipboard_item_to_clipboard (_tmp0_, _tmp1_);
#line 310 "clipboard-manager.c"
}


void diodon_clipboard_manager_select_item (DiodonClipboardManager* self, DiodonIClipboardItem* item) {
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 116 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	DIODON_CLIPBOARD_MANAGER_GET_CLASS (self)->select_item (self, item);
#line 319 "clipboard-manager.c"
}


/**
         * Clear managed clipboard 
         */
void diodon_clipboard_manager_clear (DiodonClipboardManager* self) {
	GtkClipboard* _tmp0_ = NULL;
#line 124 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	gtk_clipboard_set_text (_tmp0_, "", -1);
#line 334 "clipboard-manager.c"
}


/**
         * Request text from managed clipboard. If result is valid
         * on_text_received will be called.
         *
         * @param event owner change event
         */
void diodon_clipboard_manager_check_clipboard (DiodonClipboardManager* self) {
	gchar* text = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gboolean text_available = FALSE;
	gboolean _tmp7_ = FALSE;
	DiodonClipboardConfiguration* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean image_available = FALSE;
	gboolean uris_available = FALSE;
	GtkClipboard* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 143 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = diodon_clipboard_manager_request_text (self);
#line 143 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	text = _tmp0_;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp3_ = text;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp3_ != NULL) {
#line 372 "clipboard-manager.c"
		const gchar* _tmp4_ = NULL;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp4_ = text;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 378 "clipboard-manager.c"
	} else {
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp2_ = FALSE;
#line 382 "clipboard-manager.c"
	}
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp2_) {
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp1_ = TRUE;
#line 388 "clipboard-manager.c"
	} else {
		GtkClipboard* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp5_ = self->_clipboard;
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp6_ = gtk_clipboard_wait_is_text_available (_tmp5_);
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp1_ = _tmp6_;
#line 398 "clipboard-manager.c"
	}
#line 144 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	text_available = _tmp1_;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp8_ = self->_configuration;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp9_ = diodon_clipboard_configuration_get_add_images (_tmp8_);
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp10_ = _tmp9_;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp10_) {
#line 410 "clipboard-manager.c"
		GtkClipboard* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp11_ = self->_clipboard;
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp12_ = gtk_clipboard_wait_is_image_available (_tmp11_);
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp7_ = _tmp12_;
#line 419 "clipboard-manager.c"
	} else {
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp7_ = FALSE;
#line 423 "clipboard-manager.c"
	}
#line 145 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	image_available = _tmp7_;
#line 146 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp13_ = self->_clipboard;
#line 146 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp14_ = gtk_clipboard_wait_is_uris_available (_tmp13_);
#line 146 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	uris_available = _tmp14_;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp17_ = text_available;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp17_) {
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp16_ = TRUE;
#line 439 "clipboard-manager.c"
	} else {
		gboolean _tmp18_ = FALSE;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp18_ = image_available;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp16_ = _tmp18_;
#line 446 "clipboard-manager.c"
	}
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp16_) {
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp15_ = TRUE;
#line 452 "clipboard-manager.c"
	} else {
		gboolean _tmp19_ = FALSE;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp19_ = uris_available;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp15_ = _tmp19_;
#line 459 "clipboard-manager.c"
	}
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (_tmp15_) {
#line 463 "clipboard-manager.c"
		gchar* origin = NULL;
		gchar* _tmp20_ = NULL;
		gboolean _tmp21_ = FALSE;
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp20_ = diodon_utility_get_path_of_active_application ();
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		origin = _tmp20_;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp21_ = text_available;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		if (_tmp21_) {
#line 475 "clipboard-manager.c"
			gboolean _tmp22_ = FALSE;
			const gchar* _tmp23_ = NULL;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			_tmp23_ = text;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			if (_tmp23_ != NULL) {
#line 482 "clipboard-manager.c"
				const gchar* _tmp24_ = NULL;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp24_ = text;
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp22_ = g_strcmp0 (_tmp24_, "") != 0;
#line 488 "clipboard-manager.c"
			} else {
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp22_ = FALSE;
#line 492 "clipboard-manager.c"
			}
#line 155 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			if (_tmp22_) {
#line 496 "clipboard-manager.c"
				gboolean _tmp25_ = FALSE;
#line 156 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp25_ = uris_available;
#line 156 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				if (_tmp25_) {
#line 502 "clipboard-manager.c"
					DiodonClipboardType _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					const gchar* _tmp28_ = NULL;
#line 157 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp26_ = self->type;
#line 157 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp27_ = text;
#line 157 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp28_ = origin;
#line 157 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					g_signal_emit_by_name (self, "on-uris-received", _tmp26_, _tmp27_, _tmp28_);
#line 514 "clipboard-manager.c"
				} else {
					DiodonClipboardType _tmp29_ = 0;
					const gchar* _tmp30_ = NULL;
					const gchar* _tmp31_ = NULL;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp29_ = self->type;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp30_ = text;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp31_ = origin;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					g_signal_emit_by_name (self, "on-text-received", _tmp29_, _tmp30_, _tmp31_);
#line 527 "clipboard-manager.c"
				}
			}
		} else {
			gboolean _tmp32_ = FALSE;
#line 165 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			_tmp32_ = image_available;
#line 165 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
			if (_tmp32_) {
#line 536 "clipboard-manager.c"
				GdkPixbuf* pixbuf = NULL;
				GdkPixbuf* _tmp33_ = NULL;
				GdkPixbuf* _tmp34_ = NULL;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp33_ = diodon_clipboard_manager_request_image (self);
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				pixbuf = _tmp33_;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_tmp34_ = pixbuf;
#line 167 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				if (_tmp34_ != NULL) {
#line 548 "clipboard-manager.c"
					DiodonClipboardType _tmp35_ = 0;
					GdkPixbuf* _tmp36_ = NULL;
					const gchar* _tmp37_ = NULL;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp35_ = self->type;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp36_ = pixbuf;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					_tmp37_ = origin;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
					g_signal_emit_by_name (self, "on-image-received", _tmp35_, _tmp36_, _tmp37_);
#line 560 "clipboard-manager.c"
				}
#line 165 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
				_g_object_unref0 (pixbuf);
#line 564 "clipboard-manager.c"
			}
		}
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_g_free0 (origin);
#line 569 "clipboard-manager.c"
	} else {
#line 174 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		diodon_clipboard_manager_check_clipboard_emptiness (self);
#line 573 "clipboard-manager.c"
	}
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_g_free0 (text);
#line 577 "clipboard-manager.c"
}


/**
         * Request image from clipboard and return it
         *
         * @return returns requested image from clipboard
         */
GdkPixbuf* diodon_clipboard_manager_request_image (DiodonClipboardManager* self) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _result_ = NULL;
	GtkClipboard* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self), NULL);
#line 185 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 185 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp1_ = gtk_clipboard_wait_for_image (_tmp0_);
#line 185 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_result_ = _tmp1_;
#line 186 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	result = _result_;
#line 186 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return result;
#line 603 "clipboard-manager.c"
}


/**
         * request text from clipboard and return it
         *
         * @return returns text available in clipboard
         */
gchar* diodon_clipboard_manager_request_text (DiodonClipboardManager* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	GtkClipboard* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 194 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self), NULL);
#line 196 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 196 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp1_ = gtk_clipboard_wait_for_text (_tmp0_);
#line 196 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_result_ = _tmp1_;
#line 197 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	result = _result_;
#line 197 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return result;
#line 629 "clipboard-manager.c"
}


/**
         * Check if clipboard content has been lost.
         */
void diodon_clipboard_manager_check_clipboard_emptiness (DiodonClipboardManager* self) {
	GdkAtom* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkClipboard* _tmp0_ = NULL;
	GdkAtom* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
#line 203 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self));
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets = NULL;
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets_length1 = 0;
#line 205 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_targets_size_ = targets_length1;
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->_clipboard;
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp3_ = gtk_clipboard_wait_for_targets (_tmp0_, &_tmp1_, &_tmp2_);
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets = (g_free (targets), NULL);
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets = _tmp1_;
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets_length1 = _tmp2_;
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_targets_size_ = targets_length1;
#line 206 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (!_tmp3_) {
#line 666 "clipboard-manager.c"
		DiodonClipboardType _tmp4_ = 0;
#line 207 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		_tmp4_ = self->type;
#line 207 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		g_signal_emit_by_name (self, "on-empty", _tmp4_);
#line 672 "clipboard-manager.c"
	}
#line 203 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	targets = (g_free (targets), NULL);
#line 676 "clipboard-manager.c"
}


DiodonClipboardType diodon_clipboard_manager_get_clipboard_type (DiodonClipboardManager* self) {
	DiodonClipboardType result;
	DiodonClipboardType _tmp0_ = 0;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_MANAGER (self), 0);
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_tmp0_ = self->type;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	result = _tmp0_;
#line 71 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	return result;
#line 691 "clipboard-manager.c"
}


static void g_cclosure_user_marshal_VOID__ENUM_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_STRING_STRING) (gpointer data1, gint arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (n_param_values == 4);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data1 = closure->data;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data2 = param_values->data[0].v_pointer;
#line 710 "clipboard-manager.c"
	} else {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data2 = closure->data;
#line 716 "clipboard-manager.c"
	}
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	callback = (GMarshalFunc_VOID__ENUM_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 722 "clipboard-manager.c"
}


static void g_cclosure_user_marshal_VOID__ENUM_OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_OBJECT_STRING) (gpointer data1, gint arg_1, gpointer arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__ENUM_OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_return_if_fail (n_param_values == 4);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data1 = closure->data;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data2 = param_values->data[0].v_pointer;
#line 741 "clipboard-manager.c"
	} else {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		data2 = closure->data;
#line 747 "clipboard-manager.c"
	}
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	callback = (GMarshalFunc_VOID__ENUM_OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_object (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 753 "clipboard-manager.c"
}


static void diodon_clipboard_manager_class_init (DiodonClipboardManagerClass * klass) {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	diodon_clipboard_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	((DiodonClipboardManagerClass *) klass)->start = diodon_clipboard_manager_real_start;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	((DiodonClipboardManagerClass *) klass)->stop = diodon_clipboard_manager_real_stop;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	((DiodonClipboardManagerClass *) klass)->select_item = diodon_clipboard_manager_real_select_item;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diodon_clipboard_manager_get_property;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_clipboard_manager_finalize;
#line 770 "clipboard-manager.c"
	/**
	         * get type of given clipboard manager
	         */
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIODON_CLIPBOARD_MANAGER_CLIPBOARD_TYPE, g_param_spec_enum ("clipboard-type", "clipboard-type", "clipboard-type", DIODON_TYPE_CLIPBOARD_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 776 "clipboard-manager.c"
	/**
	         * Called when text from the clipboard has been received
	         * 
	         * @param type type of clipboard text belongs to
	         * @param text received text from clipboard which is never null or empty
	         */
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_new ("on_text_received", DIODON_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING_STRING, G_TYPE_NONE, 3, DIODON_TYPE_CLIPBOARD_TYPE, G_TYPE_STRING, G_TYPE_STRING);
#line 785 "clipboard-manager.c"
	/**
	         * Called when uris have been received from clipboard.
	         * The given paths are not uris appended with file://
	         * but just full paths.
	         *
	         * @param type type of clipboard uris belong to
	         * @param paths paths separated with /n.
	         */
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_new ("on_uris_received", DIODON_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING_STRING, G_TYPE_NONE, 3, DIODON_TYPE_CLIPBOARD_TYPE, G_TYPE_STRING, G_TYPE_STRING);
#line 796 "clipboard-manager.c"
	/**
	         * Called when a image has been received from the clipboard.
	         *
	         * @param type type of clipboard image belongs to
	         * @param pixbuf image as a pixbuf object
	         */
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_new ("on_image_received", DIODON_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_OBJECT_STRING, G_TYPE_NONE, 3, DIODON_TYPE_CLIPBOARD_TYPE, GDK_TYPE_PIXBUF, G_TYPE_STRING);
#line 805 "clipboard-manager.c"
	/**
	         * Called when the clipboard is empty
	         *
	         * @param type type of clipboard which is empty
	         */
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	g_signal_new ("on_empty", DIODON_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, DIODON_TYPE_CLIPBOARD_TYPE);
#line 813 "clipboard-manager.c"
}


static void diodon_clipboard_manager_instance_init (DiodonClipboardManager * self) {
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	self->_clipboard = NULL;
#line 820 "clipboard-manager.c"
}


static void diodon_clipboard_manager_finalize (GObject* obj) {
	DiodonClipboardManager * self;
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_CLIPBOARD_MANAGER, DiodonClipboardManager);
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_g_object_unref0 (self->_clipboard);
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	_g_object_unref0 (self->_configuration);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	G_OBJECT_CLASS (diodon_clipboard_manager_parent_class)->finalize (obj);
#line 834 "clipboard-manager.c"
}


/**
     * This class is in charge of retrieving information from
     * the encapsulated gnome clipboard and passing on such to the processes connected
     * to the given signals.
     */
GType diodon_clipboard_manager_get_type (void) {
	static volatile gsize diodon_clipboard_manager_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_clipboard_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonClipboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_clipboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonClipboardManager), 0, (GInstanceInitFunc) diodon_clipboard_manager_instance_init, NULL };
		GType diodon_clipboard_manager_type_id;
		diodon_clipboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonClipboardManager", &g_define_type_info, 0);
		g_once_init_leave (&diodon_clipboard_manager_type_id__volatile, diodon_clipboard_manager_type_id);
	}
	return diodon_clipboard_manager_type_id__volatile;
}


static void _vala_diodon_clipboard_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DiodonClipboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIODON_TYPE_CLIPBOARD_MANAGER, DiodonClipboardManager);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		case DIODON_CLIPBOARD_MANAGER_CLIPBOARD_TYPE:
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		g_value_set_enum (value, diodon_clipboard_manager_get_clipboard_type (self));
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		break;
#line 866 "clipboard-manager.c"
		default:
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-manager.vala"
		break;
#line 872 "clipboard-manager.c"
	}
}



