/* preferences-view.c generated by valac 0.32.1, the Vala compiler
 * generated from preferences-view.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <config.h>
#include <float.h>
#include <math.h>
#include <libpeas-gtk/peas-gtk.h>
#include <libpeas/peas.h>


#define DIODON_TYPE_PREFERENCES_VIEW (diodon_preferences_view_get_type ())
#define DIODON_PREFERENCES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_PREFERENCES_VIEW, DiodonPreferencesView))
#define DIODON_PREFERENCES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_PREFERENCES_VIEW, DiodonPreferencesViewClass))
#define DIODON_IS_PREFERENCES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_PREFERENCES_VIEW))
#define DIODON_IS_PREFERENCES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_PREFERENCES_VIEW))
#define DIODON_PREFERENCES_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_PREFERENCES_VIEW, DiodonPreferencesViewClass))

typedef struct _DiodonPreferencesView DiodonPreferencesView;
typedef struct _DiodonPreferencesViewClass DiodonPreferencesViewClass;
typedef struct _DiodonPreferencesViewPrivate DiodonPreferencesViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DIODON_TYPE_CLIPBOARD_CONFIGURATION (diodon_clipboard_configuration_get_type ())
#define DIODON_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfiguration))
#define DIODON_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))
#define DIODON_IS_CLIPBOARD_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_IS_CLIPBOARD_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_CONFIGURATION))
#define DIODON_CLIPBOARD_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_CONFIGURATION, DiodonClipboardConfigurationClass))

typedef struct _DiodonClipboardConfiguration DiodonClipboardConfiguration;
typedef struct _DiodonClipboardConfigurationClass DiodonClipboardConfigurationClass;
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DiodonPreferencesView {
	GObject parent_instance;
	DiodonPreferencesViewPrivate * priv;
};

struct _DiodonPreferencesViewClass {
	GObjectClass parent_class;
};

struct _DiodonPreferencesViewPrivate {
	GtkDialog* preferences;
};

struct _Block1Data {
	int _ref_count_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* configuration;
};

struct _Block2Data {
	int _ref_count_;
	Block1Data * _data1_;
	GtkSpinButton* recent_items_size;
};


static gpointer diodon_preferences_view_parent_class = NULL;

GType diodon_preferences_view_get_type (void) G_GNUC_CONST;
#define DIODON_PREFERENCES_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_PREFERENCES_VIEW, DiodonPreferencesViewPrivate))
enum  {
	DIODON_PREFERENCES_VIEW_DUMMY_PROPERTY
};
DiodonPreferencesView* diodon_preferences_view_new (void);
DiodonPreferencesView* diodon_preferences_view_construct (GType object_type);
GType diodon_clipboard_configuration_get_type (void) G_GNUC_CONST;
void diodon_preferences_view_show (DiodonPreferencesView* self, DiodonClipboardConfiguration* configuration);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
gboolean diodon_clipboard_configuration_get_use_clipboard (DiodonClipboardConfiguration* self);
static void ____lambda6_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_use_clipboard (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean diodon_clipboard_configuration_get_use_primary (DiodonClipboardConfiguration* self);
static void ____lambda7_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_use_primary (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean diodon_clipboard_configuration_get_add_images (DiodonClipboardConfiguration* self);
static void ____lambda8_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_add_images (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean diodon_clipboard_configuration_get_synchronize_clipboards (DiodonClipboardConfiguration* self);
static void ____lambda9_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_synchronize_clipboards (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean diodon_clipboard_configuration_get_keep_clipboard_content (DiodonClipboardConfiguration* self);
static void ____lambda10_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_keep_clipboard_content (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean diodon_clipboard_configuration_get_instant_paste (DiodonClipboardConfiguration* self);
static void ____lambda11_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_instant_paste (DiodonClipboardConfiguration* self, gboolean value);
static void _____lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gint diodon_clipboard_configuration_get_recent_items_size (DiodonClipboardConfiguration* self);
static void ____lambda12_ (Block2Data* _data2_);
void diodon_clipboard_configuration_set_recent_items_size (DiodonClipboardConfiguration* self, gint value);
static void _____lambda12__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static void ____lambda13_ (Block2Data* _data2_);
static void _____lambda13__gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self);
void diodon_preferences_view_hide (DiodonPreferencesView* self);
static void _diodon_preferences_view_hide_gtk_button_clicked (GtkButton* _sender, gpointer self);
void diodon_preferences_view_reset (DiodonPreferencesView* self);
static void _diodon_preferences_view_reset_gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void diodon_preferences_view_finalize (GObject* obj);


DiodonPreferencesView* diodon_preferences_view_construct (GType object_type) {
	DiodonPreferencesView * self = NULL;
#line 31 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = (DiodonPreferencesView*) g_object_new (object_type, NULL);
#line 31 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	return self;
#line 146 "preferences-view.c"
}


DiodonPreferencesView* diodon_preferences_view_new (void) {
#line 31 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	return diodon_preferences_view_construct (DIODON_TYPE_PREFERENCES_VIEW);
#line 153 "preferences-view.c"
}


/**
         * Show preferences view
         *
         * @param configuraiton configuration to initialize dialog
         */
static gpointer _g_object_ref0 (gpointer self) {
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 165 "preferences-view.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	return _data1_;
#line 174 "preferences-view.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 183 "preferences-view.c"
		DiodonPreferencesView* self;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		self = _data1_->self;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		_g_object_unref0 (_data1_->configuration);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		_g_object_unref0 (self);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		g_slice_free (Block1Data, _data1_);
#line 193 "preferences-view.c"
	}
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	return _data2_;
#line 203 "preferences-view.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 212 "preferences-view.c"
		DiodonPreferencesView* self;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		self = _data2_->_data1_->self;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		_g_object_unref0 (_data2_->recent_items_size);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		block1_data_unref (_data2_->_data1_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		_data2_->_data1_ = NULL;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		g_slice_free (Block2Data, _data2_);
#line 224 "preferences-view.c"
	}
}


static void ____lambda6_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_use_clipboard (_tmp1_);
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_use_clipboard (_tmp0_, !_tmp3_);
#line 250 "preferences-view.c"
}


static void _____lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda6_ (self);
#line 257 "preferences-view.c"
}


static void ____lambda7_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_use_primary (_tmp1_);
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_use_primary (_tmp0_, !_tmp3_);
#line 282 "preferences-view.c"
}


static void _____lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda7_ (self);
#line 289 "preferences-view.c"
}


static void ____lambda8_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_add_images (_tmp1_);
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 69 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_add_images (_tmp0_, !_tmp3_);
#line 314 "preferences-view.c"
}


static void _____lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda8_ (self);
#line 321 "preferences-view.c"
}


static void ____lambda9_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_synchronize_clipboards (_tmp1_);
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 77 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_synchronize_clipboards (_tmp0_, !_tmp3_);
#line 346 "preferences-view.c"
}


static void _____lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda9_ (self);
#line 353 "preferences-view.c"
}


static void ____lambda10_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_keep_clipboard_content (_tmp1_);
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 85 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_keep_clipboard_content (_tmp0_, !_tmp3_);
#line 378 "preferences-view.c"
}


static void _____lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda10_ (self);
#line 385 "preferences-view.c"
}


static void ____lambda11_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data1_->configuration;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = diodon_clipboard_configuration_get_instant_paste (_tmp1_);
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp3_ = _tmp2_;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_instant_paste (_tmp0_, !_tmp3_);
#line 410 "preferences-view.c"
}


static void _____lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda11_ (self);
#line 417 "preferences-view.c"
}


static void ____lambda12_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	GtkSpinButton* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data2_->recent_items_size;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = gtk_spin_button_get_value_as_int (_tmp1_);
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_recent_items_size (_tmp0_, _tmp2_);
#line 439 "preferences-view.c"
}


static void _____lambda12__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda12_ (self);
#line 446 "preferences-view.c"
}


static void ____lambda13_ (Block2Data* _data2_) {
	Block1Data* _data1_;
	DiodonPreferencesView* self;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	GtkSpinButton* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = _data2_->_data1_;
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = _data1_->self;
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = _data1_->configuration;
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _data2_->recent_items_size;
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = gtk_spin_button_get_value_as_int (_tmp1_);
#line 104 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_clipboard_configuration_set_recent_items_size (_tmp0_, _tmp2_);
#line 468 "preferences-view.c"
}


static void _____lambda13__gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self) {
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	____lambda13_ (self);
#line 475 "preferences-view.c"
}


static void _diodon_preferences_view_hide_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_preferences_view_hide ((DiodonPreferencesView*) self);
#line 482 "preferences-view.c"
}


static void _diodon_preferences_view_reset_gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
#line 119 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_preferences_view_reset ((DiodonPreferencesView*) self);
#line 489 "preferences-view.c"
}


void diodon_preferences_view_show (DiodonPreferencesView* self, DiodonClipboardConfiguration* configuration) {
	Block1Data* _data1_;
	DiodonClipboardConfiguration* _tmp0_ = NULL;
	DiodonClipboardConfiguration* _tmp1_ = NULL;
	GtkDialog* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_return_if_fail (DIODON_IS_PREFERENCES_VIEW (self));
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_return_if_fail (DIODON_IS_CLIPBOARD_CONFIGURATION (configuration));
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_->_ref_count_ = 1;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_->self = g_object_ref (self);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = configuration;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_g_object_unref0 (_data1_->configuration);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_->configuration = _tmp1_;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp2_ = self->priv->preferences;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	if (_tmp2_ == NULL) {
#line 521 "preferences-view.c"
		{
			Block2Data* _data2_;
			GtkBuilder* builder = NULL;
			GtkBuilder* _tmp3_ = NULL;
			GtkBuilder* _tmp4_ = NULL;
			GtkBuilder* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			GtkToggleButton* use_clipboard = NULL;
			GtkBuilder* _tmp8_ = NULL;
			GObject* _tmp9_ = NULL;
			GtkToggleButton* _tmp10_ = NULL;
			GtkToggleButton* _tmp11_ = NULL;
			DiodonClipboardConfiguration* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			GtkToggleButton* _tmp15_ = NULL;
			GtkToggleButton* use_primary = NULL;
			GtkBuilder* _tmp16_ = NULL;
			GObject* _tmp17_ = NULL;
			GtkToggleButton* _tmp18_ = NULL;
			GtkToggleButton* _tmp19_ = NULL;
			DiodonClipboardConfiguration* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			GtkToggleButton* _tmp23_ = NULL;
			GtkToggleButton* add_images = NULL;
			GtkBuilder* _tmp24_ = NULL;
			GObject* _tmp25_ = NULL;
			GtkToggleButton* _tmp26_ = NULL;
			GtkToggleButton* _tmp27_ = NULL;
			DiodonClipboardConfiguration* _tmp28_ = NULL;
			gboolean _tmp29_ = FALSE;
			gboolean _tmp30_ = FALSE;
			GtkToggleButton* _tmp31_ = NULL;
			GtkToggleButton* synchronize_clipboards = NULL;
			GtkBuilder* _tmp32_ = NULL;
			GObject* _tmp33_ = NULL;
			GtkToggleButton* _tmp34_ = NULL;
			GtkToggleButton* _tmp35_ = NULL;
			DiodonClipboardConfiguration* _tmp36_ = NULL;
			gboolean _tmp37_ = FALSE;
			gboolean _tmp38_ = FALSE;
			GtkToggleButton* _tmp39_ = NULL;
			GtkToggleButton* keep_clipboard_content = NULL;
			GtkBuilder* _tmp40_ = NULL;
			GObject* _tmp41_ = NULL;
			GtkToggleButton* _tmp42_ = NULL;
			GtkToggleButton* _tmp43_ = NULL;
			DiodonClipboardConfiguration* _tmp44_ = NULL;
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_ = FALSE;
			GtkToggleButton* _tmp47_ = NULL;
			GtkToggleButton* instant_paste = NULL;
			GtkBuilder* _tmp48_ = NULL;
			GObject* _tmp49_ = NULL;
			GtkToggleButton* _tmp50_ = NULL;
			GtkToggleButton* _tmp51_ = NULL;
			DiodonClipboardConfiguration* _tmp52_ = NULL;
			gboolean _tmp53_ = FALSE;
			gboolean _tmp54_ = FALSE;
			GtkToggleButton* _tmp55_ = NULL;
			GtkBuilder* _tmp56_ = NULL;
			GObject* _tmp57_ = NULL;
			GtkSpinButton* _tmp58_ = NULL;
			GtkSpinButton* _tmp59_ = NULL;
			DiodonClipboardConfiguration* _tmp60_ = NULL;
			gint _tmp61_ = 0;
			gint _tmp62_ = 0;
			GtkSpinButton* _tmp63_ = NULL;
			GtkSpinButton* _tmp64_ = NULL;
			PeasGtkPluginManager* manager = NULL;
			PeasEngine* _tmp65_ = NULL;
			PeasGtkPluginManager* _tmp66_ = NULL;
			GtkBox* plugins_box = NULL;
			GtkBuilder* _tmp67_ = NULL;
			GObject* _tmp68_ = NULL;
			GtkBox* _tmp69_ = NULL;
			GtkBox* _tmp70_ = NULL;
			PeasGtkPluginManager* _tmp71_ = NULL;
			GtkButton* close = NULL;
			GtkBuilder* _tmp72_ = NULL;
			GObject* _tmp73_ = NULL;
			GtkButton* _tmp74_ = NULL;
			GtkButton* _tmp75_ = NULL;
			GtkBuilder* _tmp76_ = NULL;
			GObject* _tmp77_ = NULL;
			GtkDialog* _tmp78_ = NULL;
			GtkDialog* _tmp79_ = NULL;
			GtkDialog* _tmp80_ = NULL;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data2_ = g_slice_new0 (Block2Data);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data2_->_ref_count_ = 1;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data2_->_data1_ = block1_data_ref (_data1_);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp3_ = gtk_builder_new ();
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			builder = _tmp3_;
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp4_ = builder;
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_builder_set_translation_domain (_tmp4_, GETTEXT_PACKAGE);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp5_ = builder;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp6_ = g_build_filename (SHAREDIR, "preferences.ui", NULL);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp7_ = _tmp6_;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_builder_add_from_file (_tmp5_, _tmp7_, &_inner_error_);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_free0 (_tmp7_);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
				_g_object_unref0 (builder);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
				block2_data_unref (_data2_);
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
				_data2_ = NULL;
#line 644 "preferences-view.c"
				goto __catch8_g_error;
			}
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp8_ = builder;
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp9_ = gtk_builder_get_object (_tmp8_, "checkbutton_use_clipboard");
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp9_) : NULL);
#line 51 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			use_clipboard = _tmp10_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp11_ = use_clipboard;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp12_ = _data1_->configuration;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp13_ = diodon_clipboard_configuration_get_use_clipboard (_tmp12_);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp14_ = _tmp13_;
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp11_, _tmp14_);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp15_ = use_clipboard;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp15_, "toggled", (GCallback) _____lambda6__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp16_ = builder;
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp17_ = gtk_builder_get_object (_tmp16_, "checkbutton_use_primary");
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp17_) : NULL);
#line 59 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			use_primary = _tmp18_;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp19_ = use_primary;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp20_ = _data1_->configuration;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp21_ = diodon_clipboard_configuration_get_use_primary (_tmp20_);
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp22_ = _tmp21_;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp19_, _tmp22_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp23_ = use_primary;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp23_, "toggled", (GCallback) _____lambda7__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp24_ = builder;
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp25_ = gtk_builder_get_object (_tmp24_, "checkbutton_add_images");
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp25_) : NULL);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			add_images = _tmp26_;
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp27_ = add_images;
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp28_ = _data1_->configuration;
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp29_ = diodon_clipboard_configuration_get_add_images (_tmp28_);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp30_ = _tmp29_;
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp27_, _tmp30_);
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp31_ = add_images;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp31_, "toggled", (GCallback) _____lambda8__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 73 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp32_ = builder;
#line 73 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp33_ = gtk_builder_get_object (_tmp32_, "checkbutton_synchronize_clipboards");
#line 73 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp34_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp33_) : NULL);
#line 73 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			synchronize_clipboards = _tmp34_;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp35_ = synchronize_clipboards;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp36_ = _data1_->configuration;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp37_ = diodon_clipboard_configuration_get_synchronize_clipboards (_tmp36_);
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp38_ = _tmp37_;
#line 75 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp35_, _tmp38_);
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp39_ = synchronize_clipboards;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp39_, "toggled", (GCallback) _____lambda9__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp40_ = builder;
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp41_ = gtk_builder_get_object (_tmp40_, "checkbutton_keep_clipboard_content");
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp41_) : NULL);
#line 81 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			keep_clipboard_content = _tmp42_;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp43_ = keep_clipboard_content;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp44_ = _data1_->configuration;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp45_ = diodon_clipboard_configuration_get_keep_clipboard_content (_tmp44_);
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp46_ = _tmp45_;
#line 83 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp43_, _tmp46_);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp47_ = keep_clipboard_content;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp47_, "toggled", (GCallback) _____lambda10__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp48_ = builder;
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp49_ = gtk_builder_get_object (_tmp48_, "checkbutton_instant_paste");
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp50_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) _tmp49_) : NULL);
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			instant_paste = _tmp50_;
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp51_ = instant_paste;
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp52_ = _data1_->configuration;
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp53_ = diodon_clipboard_configuration_get_instant_paste (_tmp52_);
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp54_ = _tmp53_;
#line 91 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_toggle_button_set_active (_tmp51_, _tmp54_);
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp55_ = instant_paste;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp55_, "toggled", (GCallback) _____lambda11__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp56_ = builder;
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp57_ = gtk_builder_get_object (_tmp56_, "spinbutton_recent_items_size");
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp58_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, gtk_spin_button_get_type ()) ? ((GtkSpinButton*) _tmp57_) : NULL);
#line 97 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data2_->recent_items_size = _tmp58_;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp59_ = _data2_->recent_items_size;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp60_ = _data1_->configuration;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp61_ = diodon_clipboard_configuration_get_recent_items_size (_tmp60_);
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp62_ = _tmp61_;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_spin_button_set_value (_tmp59_, (gdouble) _tmp62_);
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp63_ = _data2_->recent_items_size;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (_tmp63_, "value-changed", (GCallback) _____lambda12__gtk_spin_button_value_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp64_ = _data2_->recent_items_size;
#line 103 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, GTK_TYPE_CELL_EDITABLE, GtkCellEditable), "editing-done", (GCallback) _____lambda13__gtk_cell_editable_editing_done, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp65_ = peas_engine_get_default ();
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp66_ = (PeasGtkPluginManager*) peas_gtk_plugin_manager_new (_tmp65_);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_object_ref_sink (_tmp66_);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			manager = _tmp66_;
#line 110 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp67_ = builder;
#line 110 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp68_ = gtk_builder_get_object (_tmp67_, "plugins_box");
#line 110 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp69_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp68_, gtk_box_get_type ()) ? ((GtkBox*) _tmp68_) : NULL);
#line 110 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			plugins_box = _tmp69_;
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp70_ = plugins_box;
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp71_ = manager;
#line 111 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_box_pack_start (_tmp70_, G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp72_ = builder;
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp73_ = gtk_builder_get_object (_tmp72_, "button_close");
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp74_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp73_, gtk_button_get_type ()) ? ((GtkButton*) _tmp73_) : NULL);
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			close = _tmp74_;
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp75_ = close;
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_object (_tmp75_, "clicked", (GCallback) _diodon_preferences_view_hide_gtk_button_clicked, self, 0);
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp76_ = builder;
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp77_ = gtk_builder_get_object (_tmp76_, "dialog_preferences");
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp78_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp77_, gtk_dialog_get_type ()) ? ((GtkDialog*) _tmp77_) : NULL);
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (self->priv->preferences);
#line 118 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			self->priv->preferences = _tmp78_;
#line 119 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp79_ = self->priv->preferences;
#line 119 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, gtk_widget_get_type (), GtkWidget), "destroy", (GCallback) _diodon_preferences_view_reset_gtk_widget_destroy, self, G_CONNECT_AFTER);
#line 120 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp80_ = self->priv->preferences;
#line 120 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, gtk_widget_get_type (), GtkWidget));
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (close);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (plugins_box);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (manager);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (instant_paste);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (keep_clipboard_content);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (synchronize_clipboards);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (add_images);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (use_primary);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (use_clipboard);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_object_unref0 (builder);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			block2_data_unref (_data2_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data2_ = NULL;
#line 881 "preferences-view.c"
		}
		goto __finally8;
		__catch8_g_error:
		{
			GError* e = NULL;
			GError* _tmp81_ = NULL;
			const gchar* _tmp82_ = NULL;
			gchar* _tmp83_ = NULL;
			gchar* _tmp84_ = NULL;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			e = _inner_error_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_inner_error_ = NULL;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp81_ = e;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp82_ = _tmp81_->message;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp83_ = g_strconcat ("Could not initialize preferences dialog. Error: ", _tmp82_, NULL);
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_tmp84_ = _tmp83_;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_warning ("preferences-view.vala:123: %s", _tmp84_);
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_free0 (_tmp84_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_g_error_free0 (e);
#line 909 "preferences-view.c"
		}
		__finally8:
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			block1_data_unref (_data1_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			_data1_ = NULL;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			g_clear_error (&_inner_error_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
			return;
#line 924 "preferences-view.c"
		}
	}
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	block1_data_unref (_data1_);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_data1_ = NULL;
#line 931 "preferences-view.c"
}


/**
         * Hide preferences view
         */
void diodon_preferences_view_hide (DiodonPreferencesView* self) {
	GtkDialog* _tmp0_ = NULL;
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_return_if_fail (DIODON_IS_PREFERENCES_VIEW (self));
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_tmp0_ = self->priv->preferences;
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_signal_emit_by_name (_tmp0_, "close");
#line 946 "preferences-view.c"
}


/**
         * Reset preferences dialog
         */
void diodon_preferences_view_reset (DiodonPreferencesView* self) {
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_return_if_fail (DIODON_IS_PREFERENCES_VIEW (self));
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_g_object_unref0 (self->priv->preferences);
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self->priv->preferences = NULL;
#line 960 "preferences-view.c"
}


static void diodon_preferences_view_class_init (DiodonPreferencesViewClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	diodon_preferences_view_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	g_type_class_add_private (klass, sizeof (DiodonPreferencesViewPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_preferences_view_finalize;
#line 971 "preferences-view.c"
}


static void diodon_preferences_view_instance_init (DiodonPreferencesView * self) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self->priv = DIODON_PREFERENCES_VIEW_GET_PRIVATE (self);
#line 978 "preferences-view.c"
}


static void diodon_preferences_view_finalize (GObject* obj) {
	DiodonPreferencesView * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_PREFERENCES_VIEW, DiodonPreferencesView);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	_g_object_unref0 (self->priv->preferences);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/preferences-view.vala"
	G_OBJECT_CLASS (diodon_preferences_view_parent_class)->finalize (obj);
#line 990 "preferences-view.c"
}


/**
     * Preferences dialog view loading user interface from preferences.ui
     */
GType diodon_preferences_view_get_type (void) {
	static volatile gsize diodon_preferences_view_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_preferences_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonPreferencesViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_preferences_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonPreferencesView), 0, (GInstanceInitFunc) diodon_preferences_view_instance_init, NULL };
		GType diodon_preferences_view_type_id;
		diodon_preferences_view_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonPreferencesView", &g_define_type_info, 0);
		g_once_init_leave (&diodon_preferences_view_type_id__volatile, diodon_preferences_view_type_id);
	}
	return diodon_preferences_view_type_id__volatile;
}



